/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/* Qualidade de Fornecimento                                                  */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: 8620_QFOSTP_TESTEPROD_UPCHILD                                        */
/*                                                                            */
/* Descrio:                                                                 */
/*  Updata o tipo de prato, marca de referncia e custo x benefcio de um     */
/*  teste de produto para todos os filhos deste teste.                        */
/*                                                                            */
/*                                                                            */
/* Criao:                                                                   */
/* 28/02/2001 - Joo Fernando dos Reis Corra                                 */
/*                                                                            */
/*                                                                            */
/******************************************************************************/
/******************************************************************************/
/* PARAMETROS:                                                                */
/* P_NRTESTEPROD  -  Nmero de teste pai.                                     */
/******************************************************************************/
/* @C:\SISTEMAS\DBA\SQL\ORACLE\8620_QFOSTP_TESTEPROD_UPCHILD.SQL              */
/* @H:\SISTEMAS\DBA\SQL\ORACLE\8620_QFOSTP_TESTEPROD_UPCHILD.SQL              */
/******************************************************************************/
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE
           O.NAME = 'TESTEPROD_UPCHILD' AND
	   TYPE = 'P' 		  AND
	   U.UID = O.UID          AND
	   U.NAME = USER)

   DROP PROCEDURE TESTEPROD_UPCHILD
GO

CREATE PROCEDURE TESTEPROD_UPCHILD
(
   @P_NRTESTEPROD VARCHAR(10)
)
AS
   DECLARE @V_TESTEFILHO_NRTESTEPROD VARCHAR(10);
BEGIN
   DECLARE C_TESTEFILHO CURSOR FOR /* RETORNA TODOS OS TESTES FILHOS */
    SELECT
       NRTESTEPROD
    FROM
       TESTEPROD
    WHERE
       NRTESPRDORIG = @P_NRTESTEPROD;
   OPEN C_TESTEFILHO;
   FETCH NEXT FROM C_TESTEFILHO INTO @V_TESTEFILHO_NRTESTEPROD;
   WHILE (@@FETCH_STATUS = 0)
   BEGIN
/*######################## TIPO DE PRATO #####################################*/

      DELETE FROM TPPRATTEST
      WHERE NRTESTEPROD = @V_TESTEFILHO_NRTESTEPROD;

      INSERT INTO TPPRATTEST (NRTESTEPROD, CDTIPOPRAT)
      (SELECT
          @V_TESTEFILHO_NRTESTEPROD,
          CDTIPOPRAT
       FROM
          TPPRATTEST
       WHERE
          NRTESTEPROD = @P_NRTESTEPROD);

/*######################## MARCA DE REFERNCIA ###############################*/

      DELETE FROM MARCTESTPR
      WHERE NRTESTEPROD = @V_TESTEFILHO_NRTESTEPROD;

      INSERT INTO MARCTESTPR (NRTESTEPROD, CDMARCA)
      (SELECT
          @V_TESTEFILHO_NRTESTEPROD,
          CDMARCA
       FROM
          MARCTESTPR
       WHERE
          NRTESTEPROD = @P_NRTESTEPROD);

/*######################## CUSTO X BENEFCIO #################################*/

      DELETE FROM CUSBENTEST
      WHERE NRTESTEPROD = @V_TESTEFILHO_NRTESTEPROD;

      INSERT INTO CUSBENTEST (NRTESTEPROD, DSCUSBENTEST)
      (SELECT
          @V_TESTEFILHO_NRTESTEPROD,
          DSCUSBENTEST
       FROM
          CUSBENTEST
       WHERE
          NRTESTEPROD = @P_NRTESTEPROD);
          
   FETCH NEXT FROM C_TESTEFILHO INTO @V_TESTEFILHO_NRTESTEPROD;
   END;
   CLOSE C_TESTEFILHO;
   DEALLOCATE C_TESTEFILHO;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'TESTEPROD_UPCHILD','4.05.121';
GO

