import {ChartViewInterface} from "@/Services/ChartView/ChartViewInterface";
import {ChartViewAbstract} from "@/Services/ChartView/ChartViewAbstract";
import {ZmartChartsApex} from "@/Services/Chats/ZmartChartsApex";
import { ChartViewService } from "../ChartViewService";

export class Donut extends ChartViewAbstract implements ChartViewInterface {
    public hasMultipleFacts: Boolean = false;

    public getWidget(dashboard: any, widget: any) {
        const height = widget[0].style;
        if (dashboard.label !== '' || dashboard.label !== null) {
            widget[0].options.title.text = dashboard.label;
        }
        widget[0].style = "background: " + dashboard.color + "; " + height;
        return widget;
    }

    public getCharts(charts: any) {
        if (charts[0].mask !== null) {
            charts[0].options.series[0].tooltip.valueFormatter = ChartViewService.getMaskFunction(charts[0].mask);
        }
        if (charts[0].options.series[0].label.formatter === null) {
            charts[0].options.series[0].label.formatter = this.getMaskRotuloPie(charts[0].mask);
        }
        return charts;
    }

    public getMaskPie(mask: string, params: any) {
        return ChartViewService.getMaskFunction(mask)(params.data.value);
    }

    public getMaskRotuloPie(mask: string) {
        return this.getMaskPie.bind(this, mask);
    }

    public setDrill(charts: any, zmartCharts: ZmartChartsApex) {
        this.zmartCharts = zmartCharts;

        charts[0].events = {
            "chartClick": this.getZmartCharts().drillEChartsBar.bind(this.getZmartCharts(), charts[0].widget),
        };

        return charts;
    }
    public getSaveViewParams(formExtra: any, values: any, cleanValues: any) {
        console.log(formExtra, values, cleanValues);
        const chartSeries = [
            {
                serieColor: [null],
                serieColors: values.serieColors || null,
                serieFields: values.serieFields || null,
                serieLabels: values.serieLabels || null,
                serieLineWidth: values.serieLineWidth || null,
                serieStacked: values.serieStacked || null,
                serieLineType: values.serieLineType || null,
                serieYAxisFormat: values.serieYAxisFormat || null,
                serieType: values.serieType || null
            }

        ];
        cleanValues.chartSeries = chartSeries;
        return cleanValues;
    }
}
